/* Copyright 2020, Michele Santullo
 * This file is part of orotool.
 *
 * Orotool is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Orotool is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Orotool.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "event.hpp"
#include <memory>

namespace eve {

class Context;

class Signal : private Event {
public:
	Signal() = delete;
	Signal(Signal&&) = default;
	Signal(const Signal&) = delete;
	Signal (int sig, const Context& ctx);
	virtual ~Signal();

	virtual void on_signal() = 0;

protected:
	using Event::set_exception;

private:
	struct LocalData;

	void on_signal_ev();
	virtual void on_loop_stopping() noexcept override;

	std::unique_ptr<LocalData> m_local;
};

} //namespace eve
